﻿using System;
using System.Threading;
using System.Collections.Generic;
using Aneka.Entity;
using Aneka.Tasks;
using Aneka.Security;
using Aneka.Data.Entity;
using Aneka.Security.Windows;
using System.Net;


namespace AnekaTaskDemo
{
    [Serializable]
    public class Test : ITask
    {
        public string executor;
        int a=20, b = 30;
        public string result;
        public Test() { }
        public void Execute()
        {
           // result = a + b;
            string hostname = Dns.GetHostName();
            IPHostEntry  host = Dns.GetHostEntry(hostname);
            executor = hostname;
            Console.WriteLine(" " + hostname);
            IPAddress[] ip1 = Dns.GetHostAddresses(hostname);
            foreach (IPAddress ip in host.AddressList)
            {
                if (ip.AddressFamily == System.Net.Sockets.AddressFamily.InterNetwork)
                {
                    //System.Diagnostics.Debug.WriteLine("LocalIPadress: " + ip);
                    result= ip.ToString();
                }
            }
        }
        public string GetExecutorNode()
        {
            return executor;
        }
        public string GetIPNode()
        {
            return result;
        }
    }
    class MyTaskDemo
    {
        
        private static AutoResetEvent semaphore;
       
        private static AnekaApplication<AnekaTask, TaskManager> app;

        
        public static void Main(string[] args)
        {
                //Configuration conf = new Configuration(); 
               // conf.SchedulerUri = new Uri("tcp://192.9.100.122:9090/Aneka");
            Aneka.Logger.Start();
            Configuration conf = Configuration.GetConfiguration(@"C:\Users\poojara\Desktop\conf.xml");
                conf.SingleSubmission = false;
                conf.ResubmitMode = ResubmitMode.MANUAL;
                conf.UseFileTransfer = false;
                app =  new AnekaApplication<AnekaTask, TaskManager>
                            ("Test", conf);
                app.WorkUnitFinished +=
                new EventHandler<WorkUnitEventArgs<AnekaTask>>
                    (OnWorkUnitFinished);
                app.WorkUnitFailed +=
                    new EventHandler<WorkUnitEventArgs<AnekaTask>>
                        (OnWorkUnitFailed);
                app.ApplicationFinished +=
                    new EventHandler<ApplicationEventArgs>(OnApplicationFinished);
                semaphore = new AutoResetEvent(false);
                Test t = new Test();
                AnekaTask gt = new AnekaTask(t);
                app.ExecuteWorkUnit(gt);
              Console.WriteLine("Submission Time " + gt.SubmissionTime);
            semaphore.WaitOne();
             //   Console.WriteLine("After semaphore");
               t = (Test)gt.UserTask;
            //   Console.WriteLine(" " + t.result);
                Aneka.Logger.Stop();
       }
        public static void OnWorkUnitFailed
            (object sender, WorkUnitEventArgs<AnekaTask> args)
        {
            
        }
        public static void OnWorkUnitFinished
            (object sender, WorkUnitEventArgs<AnekaTask> args)
        {
            Console.WriteLine("WorkUnit Finished");
            Test task = args.WorkUnit.UserTask as Test;
            Console.WriteLine("hostname : " + task.GetExecutorNode());
            Console.WriteLine("IP adress : " + task.GetIPNode());
           
            app.StopExecution();
            
        }
        public static void
               OnApplicationFinished(object sender, ApplicationEventArgs args)
        {
            //Console.WriteLine("Application Finished");
            semaphore.Set();
            Console.WriteLine("Application Finished"); 
          
        }

    }
}
